#include <windows.h>
#include <stdio.h>
#include <winsock2.h>
 
#pragma comment(lib, "Ws2.lib")
 
/// Set IP address and port number according to server IP address and port number
#define SERVER_IP_ADDRESS    "10.18.0.100"
#define PORT_NUMBER          23
#define BUFFER_SIZE          255

#define ASCII_CTRLZ			"26"		///< ASCII of CTRT+Z or EOF to exit from code. 

HANDLE hCom;	///< Handle for thread
SOCKET commSocket;	///< Structure to contain SOCKET configuration
HANDLE myEvent;		///< Handle to Event declared

DWORD retVal;
CHAR sendBuffer[BUFFER_SIZE] = {0};


/// Thread for Sending data
DWORD SendThreadProc(LPVOID hCom)
{
	while(1)
	{
		WaitForSingleObject(myEvent, INFINITE);
		retVal = send(commSocket, sendBuffer, strlen(sendBuffer), 0);
		if (retVal == SOCKET_ERROR)
		{
			printf("\nCould not send message to Server with error code : %d", WSAGetLastError());
			CloseHandle(myEvent);
			return 0;
		}
	sendBuffer[0] = '\0';
	}
}

/// Thread for receiving data
DWORD ReceiveThreadProc(LPVOID hCom)
{
	char recvBuffer[BUFFER_SIZE] = {0};

	while(1)
	{
		retVal = recv(commSocket, recvBuffer, BUFFER_SIZE, 0);  ///< Receive from server
		if (retVal == SOCKET_ERROR)
		{
			printf("\nCould not receive from Server with error code : %d", WSAGetLastError());
			return 0;
			//break;
		}
		else if(retVal == 0)
		{
			break;
		}
		else
		{
			printf("Data Received: %s\n", recvBuffer);
			//break;
		}
	}
}

int wmain()
{
    DWORD choice = 0;
	DWORD oldMode = 0;
    BOOL loopMenu = TRUE;
    WSADATA ws;                ///< Structure to contain information about the Windows Socket implementation
    struct sockaddr_in serverinfo;	

	myEvent = CreateEventW(NULL, FALSE, FALSE, NULL);				///< Creating an Event to enter data on console

    retVal = WSAStartup(0x0101, &ws);                              ///< Initialize ws2.dll (library used for socket programming)
    if (retVal != 0)                                               ///< If WSAStartup failed to initialize
    {
        printf("WSAStartup failed with error: %d\n", WSAGetLastError());
        exit(1);
    }
 
    commSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);        ///< Socket creation
    if (commSocket == INVALID_SOCKET)
    {
        printf("\nSocket creation failed with error code : %d", WSAGetLastError());
        WSACleanup();
        exit(1);
    }
 
    /// Socket binding
    serverinfo.sin_family = AF_INET;                                ///< TCP/UDP socket
    serverinfo.sin_addr.s_addr = inet_addr(SERVER_IP_ADDRESS);      ///< IP Address of Server
    serverinfo.sin_port = htons(PORT_NUMBER);                       ///< Port number used for communication
 
    retVal = connect(commSocket, (LPSOCKADDR)&serverinfo, sizeof(struct sockaddr));   ///< Connect to Server
    if (retVal == SOCKET_ERROR)
    {
        printf("\nCould not connect to Server with error code : %d", WSAGetLastError()); 
        WSACleanup();
        return FALSE;
    }
	printf("Demo program to send and receive data over LAN using Multi Threading,\nToradex Module as client"
		"\n*****PRESS CTRL + Z and ENTER to EXIT*****\n"); 

	CreateThread(NULL, 0, SendThreadProc, hCom, 0, NULL);		///< Thread declaration to Send Data
	CreateThread(NULL, 0, ReceiveThreadProc, hCom, 0, NULL);	///< Thread declaration to Receive Data

	while(!feof(stdin))
	{
		scanf_s("%s", &sendBuffer);
		if(sendBuffer == ASCII_CTRLZ)
		{
			break;
		}
		else
		{
			if(!SetEvent(myEvent))		///< Setting Event Flag
			{
				printf("Event not Set: %d", GetLastError());
				break;
			}
		}
	}
	closesocket(commSocket);
	WSACleanup();                       ///< Releasing ws2.dll
    return TRUE;
}